      SUBROUTINE MAP_STEEL_RCOOL(AB4,J2,J3,COTEMP,COTIME)
      IMPLICIT NONE
      DOUBLE PRECISION COTEMP(1000),COTIME(1000),RTEMP(100),RTIME(100)
      DOUBLE PRECISION AB4, STEMP, STIME
C
      INTEGER I, IA, J, JA, J2, J3, J5
C
      OPEN (UNIT=4, FILE='cooling')
C
      DO 10 J = 1,100
         READ(4,*,END=15) RTIME(J), RTEMP(J)
10     CONTINUE
C
15    J3 = J-1
C
C To divide each time and temperature interval into AB4 steps (this is 
C set in the main program). STEMP and STIME are arrays of the step sizes.
C COTIME and COTEMP are arrays of the time temp pairs for the calculation. 
C
      DO 25 JA = 1,J3-1
       STEMP = (RTEMP(JA)-RTEMP(JA+1))/AB4
       STIME = (RTIME(JA+1)-RTIME(JA))/AB4
C
       DO 20 IA = 1,AB4
        I = AB4*(JA-1)+IA
        COTEMP(I) = RTEMP(JA)-STEMP*(IA-1)
        COTIME(I) = RTIME(JA)+STIME*(IA-1)
20     CONTINUE
C
25    CONTINUE
C
      J2 = AB4*(J3-1)+1
C
      COTEMP(J2)=RTEMP(J3)
      COTIME(J2)=RTIME(J3)
C
C To convert the temperature into K.
C
       DO 30 J5=1,J2
          COTEMP(J5)=COTEMP(J5)+273.0D0
30     CONTINUE
C
       CLOSE(4)
       RETURN
       END
